#!/usr/bin/perl
#
# Copyright (C) Warren D. MacEvoy, 1998, under the Gnu Public License.
# See the file Copying for details.
#
print("#!$perlloc -w\n");
print("\$perlloc=\"$perlloc\";\n");
print('
#
# Copyright (C) Warren D. MacEvoy, 1998, under the Gnu Public License.
# See the file Copying for details.
#
# Mod 19991229 [AGP] Alberto González Palomo <matmota@matracas.com>
#              Fixed a bug that prevented the second of two joint quotes
#              (double or single ones) from being backslash escaped.
');
print('
');
print('$of=undef;
');
print('$if=undef;
');
print('$pl=0;
');
print('$quote=q{\'};
');
print('for ($i=0; $i<=$#ARGV; ++$i) {
');
print('    if ($ARGV[$i] eq "-pl") { $pl=1; next; }
');
print('    if ($ARGV[$i] eq "-q") { $quote=q{\'}; next; }
');
print('    if ($ARGV[$i] eq "-qq") { $quote=q{"}; next; }
');
print('    if ($ARGV[$i] eq "-perl") { $perlloc=$ARGV[$i+1]; ++$i; next; }
');
print('    if ($ARGV[$i] eq "-o") { $of=$ARGV[$i+1]; ++$i; next; }
');
print('    last;
');
print('}
');
print('
');
print('$if=$ARGV[$i] if ($i<=$#ARGV);
');
print('@args=@ARGV[$i+1..$#ARGV];
');
print('
');
print('if (!defined($if) || ($if eq "-")) {
');
print('    open(IF,"<&STDIN");
');
print('    $if=undef;
');
print('} else {
');
print('    open(IF,"<$if");
');
print('}
');
print('
');
print('if ((!defined($of) && !defined($if)) || (defined($of) && $of eq "-")) {
');
print('    if ($pl==0) {
');
print('	$args=join(\' \',@args);
');
print('	open(OF,"|$perlloc -w - $args");
');
print('    } else {
');
print('	open(OF,">&STDOUT");
');
print('    }
');
print('    $of=undef;
');
print('} else {
');
print('    if (!defined($of)) {
');
print('	$of=$if;
');
print('	if ($pl==0) {
');
print('	    $of =~ s/\\.ppp$//;
');
print('	} else {
');
print('	    $of =~ s/\\.ppp$/\\.pl/;
');
print('	}
');
print('    }
');
print('    if ($pl==0) {
');
print('	$args=join(\' \',@args);
');
print('	open(OF,"|$perlloc - $args>$of");
');
print('    } else {
');
print('	open(OF,">$of");
');
print('    }
');
print('}
');
print('	
');
print('print OF (\'#!\',$perlloc,"\\n");
');
print('while (<IF>) {
');
print('    $action=$quote;
');
print('    if (m/^([\\"\\\'\\`!])/) {
');
print('      $action=$1;
');
print('      $_=substr($_,1);
');
print('    };
');
print('    if ($action eq \'!\') { print OF; next; }
');
print('    if ($action eq \'"\') {
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\\"/$1\\\\\\"/g; # escape unescaped double-quotes
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\"/$1\\\\\\"/g; # [AGP] re-escape unescaped double-quotes
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\\\\$/\\\\\\\\/g;  # escape an unescaped trailing backslash
');
print('      
');
print('      print OF ("print(\\"$_\\");\\n");
');
print('    } elsif ($action eq \'`\') {
');
print('      chomp;
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\\`/$1\\\\\\`/g; # escape unescaped back-quotes
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\`/$1\\\\\\`/g; # [AGP] re-escape unescaped back-quotes
');
print('      s/(([^\\\\]|^)(\\\\\\\\)*)\\\\$/\\\\\\\\/g;  # escape an unescaped trailing backslash
');
print('      print OF ("print(\\`$_\\`);\\n");
');
print('    } else {
');
print('      s/\\\\/\\\\\\\\/g; # escape all backslashes
');
print('      s/\\\'/\\\\\\\'/g; # escape unescaped single quotes
');
print('      print OF ("print(\\\'$_\\\');\\n");
');
print('    }
');
print('}
');
print('
');
print('close(IF) if defined($if);
');
print('close(OF) if defined($of);
');
print('
');
print('system("chmod +x $of") if defined($of) && $pl;
');
